// 
// このコードは、https://demo.mescius.jp/diodocs/pdf のサンプルの一部として提供されています。
// © MESCIUS inc. All rights reserved.
// 
using System.IO;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Pdf.AcroForms;

namespace DsPdfWeb.Demos
{
    // このサンプルは、デジタル署名された PDF から既存の署名を見つけて
    // 削除する方法を示します。代わりに署名フィールドを削除するコードに
    // ついては、RemoveSignatureFieldsを参照してください。
    // このサンプルで使用されている PD Fは、TimeSheetによって作成されました。
    public class RemoveSignatures
    {
        public int CreatePDF(Stream stream)
        {
            var doc = new GcPdfDocument();
            using (var fs = File.OpenRead(Path.Combine("Resources", "PDFs", "TimeSheet.pdf")))
            {
                doc.Load(fs);

                // フィールドは他のフィールドの子になる可能性があるため、
                // 再帰メソッドを使用してツリー全体を反復処理します。
                removeSignatures(doc.AcroForm.Fields);

                // PDF ドキュメントを保存します。
                doc.Save(stream);
                return doc.Pages.Count;

                void removeSignatures(FieldCollection fields)
                {
                    foreach (var f in fields)
                    {
                        if (f is SignatureField sf)
                            sf.Value = null;
                        removeSignatures(f.Children);
                    }
                }
            }
        }
    }
}
